<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div>

  <div class="modal-header">
    <h4
      class="modal-title"
      id="modal-basic-title"
      [innerText]="templateType | templateTypeName">
    </h4>

    <button
      type="button"
      class="btn-close"
      [title]="commonMessages.CLOSE"
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
  </div>

  <div class="modal-body">

    <!-- PDF template -->

    <ng-container *ngIf="isPdfTemplate() || isSignatureTemplate()">
      <ul
        ngbNav
        #nav="ngbNav"
        class="ip-tabs"
        (navChange)="onNavElementClicked($event)">

        <li
          [ngbNavItem]="tabEnum.Model"
          [destroyOnHide]="false">
          <a ngbNavLink [innerText]="isPdfTemplate() ? messages.TAB_MODEL : messages.TAB_SIGNATURE_TEMPLATE"></a>
          <ng-template ngbNavContent>
            <form class="mt-4 mx-3 ls-form">
              <div class="form-group">
                <label
                  [innerText]="isPdfTemplate() ? messages.TEMPLATE : messages.SIGNATURE_TEMPLATE"
                  for="templateEditor">
                </label>
                <app-monaco-editor
                  [code]="originalTemplate"
                  (codeChange)="editedTemplate = $event"
                  id="templateEditor"
                  class="border-light"
                  [language]="templateLanguage">
                </app-monaco-editor>
              </div>
            </form>
          </ng-template>
        </li>

        <li
          [ngbNavItem]="tabEnum.Example"
          [destroyOnHide]="false">
          <a ngbNavLink [innerText]="commonMessages.TAB_EXAMPLE"></a>
          <ng-template ngbNavContent>
            <app-pdf-example
              [pdfSource]="templateSrc"
              [lastModificationDate]="lastModificationDate">
            </app-pdf-example>
          </ng-template>
        </li>

      </ul>

      <div
        class="p-4"
        [ngbNavOutlet]="nav">
      </div>

    </ng-container>

    <!-- Mail template -->

    <ng-container *ngIf="isMailTemplate()">

      <form class="mt-4 mx-3 ls-form">

        <div
          class="form-group">
          <label
            for="mailTestInput"
            [innerText]="messages.MAIL_TEST_">
          </label>
          <div class="d-flex flex-row">

            <input
              id="mailTestInput"
              class="flex-grow-1 me-2"
              name="mailTestInput"
              [(ngModel)]="testMail"
              type="email"
              required
              minlength="2">

            <button
              ls-button
              [icon]="mailIcon"
              [disabled]="!isRfc5322ValidMailFn(testMail)"
              [text]="messages.TEST_TEMPLATE"
              [processing]="isTestMailProcessing"
              (click)="onTestMailButtonClicked()">
            </button>
          </div>
        </div>

        <div class="form-group">
          <label
            for="mailTemplateEditor"
            [innerText]="messages.TEMPLATE">
          </label>
          <app-monaco-editor
            class="border-light"
            id="mailTemplateEditor"
            language="xml"
            [code]="originalTemplate"
            (codeChange)="editedTemplate = $event">
          </app-monaco-editor>
        </div>
      </form>
    </ng-container>

  </div>

  <div class="modal-footer">
    <button
      ls-button-cancel
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
    <button
      ls-button
      [style]="styleEnum.DANGER"
      (click)="onDeleteButtonClicked()"
      [disabled]="creationMode || isSaveProcessing"
      [icon]="commonIcons.RE_INIT_ICON"
      [processing]="isDeleteProcessing"
      [text]="commonMessages.RESET">
    </button>
    <button
      ls-button-save
      (click)="onSaveButtonClicked()"
      [disabled]="isDeleteProcessing"
      [processing]="isSaveProcessing">
    </button>
  </div>

</div>
